﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using System.Web.Routing;

namespace WebApplication
{
    // Note: For instructions on enabling IIS6 or IIS7 classic mode, 
    // visit http://go.microsoft.com/?LinkId=9394801

    public class MvcApplication : System.Web.HttpApplication
    {
        public static void RegisterRoutes(RouteCollection routes)
        {
            routes.IgnoreRoute("{resource}.axd/{*pathInfo}");

            routes.MapRoute(
                "Default",                                              // Route name
                "{controller}/{action}",                           // URL with parameters
                new { controller = "Portlet", action = "Portal"}  // Parameter defaults
            );


            routes.MapRoute(
                "UnActivePortlets",                                              // Route name
                "Portlet/UnActivePortlets",                           // URL with parameters
                new { controller = "Portlet", action = "UnActivePortlets"}  // Parameter defaults
            );



            routes.MapRoute(
              "portletName",                                              // Route name
              "Portlet/Content/{portlet_ID}/{page}/{portletName}",                           // URL with parameters
              new { controller = "Portlet", action = "Content", portlet_ID = "", page = "", portletName = "" }  // Parameter defaults
            );

            
            routes.MapRoute(
              "PortletsPlacementManager",                                              // Route name
              "Portlet/PortletsPlacementManager/{column_ID}/{portlet_ID}/{row_No}/{is_Drop}",                           // URL with parameters
              new { controller = "Portlet", action = "PortletsPlacementManager", column_ID = "", portlet_ID = "", row_No = "", is_Drop = "" }  // Parameter defaults
            );

            routes.MapRoute(
              "PortletsStatusManager",                                              // Route name
              "Portlet/PortletsStatusManager/{portlet_ID}/{is_Active}",                           // URL with parameters
              new { controller = "Portlet", action = "PortletsStatusManager", portlet_ID = "", is_Active = "" }  // Parameter defaults
            );

         
            routes.MapRoute(
            "TotalCatetogoryPortlets",                                              // Route name
            "Portlet/TotalCatetogoryPortlets/{category_ID}/{is_Active}",                           // URL with parameters
            new { controller = "Portlet", action = "TotalCatetogoryPortlets", category_ID = "", is_Active = "" }  // Parameter defaults
          );

            routes.MapRoute(
            "TotalPortlets",                                              // Route name
            "Portlet/TotalPortlets/{is_Active}",                           // URL with parameters
            new { controller = "Portlet", action = "TotalPortlets", is_Active = "" }  // Parameter defaults
          );

             routes.MapRoute(
              "GetItemDetail",                                              // Route name
              "Portlet/GetItemDetail/{portlet_ID}/{item_No}",                           // URL with parameters
              new { controller = "Portlet", action = "GetItemDetail", portlet_ID = "", item_No = "" }  // Parameter defaults
            );
        }

        protected void Application_Start()
        {
            RegisterRoutes(RouteTable.Routes);

            WebApplication.Models.Data data = new WebApplication.Models.Data();

            data.AddCategory("Favourites");
            data.AddPortlet("http://www.harpers.org/rss/frontpage-rss20.xml", 1, "Harper", 1, false);
            data.AddPortlet("http://feeds.nationalgeographic.com/ng/NGM/NGM_Magazine", 2, "NGM Magazine", 2, false);
            data.AddPortlet("http://web.mit.edu/newsoffice/topic/security-studies.feed", 2, "New office", 3, false);
            data.AddPortlet("http://web.mit.edu/newsoffice/topic/mathematics.feed", 3, "Mathematics", 4, false);

            data.AddCategory("News");
            data.AddPortlet("http://rss.news.yahoo.com/rss/topstories", 1, "Yahoo Top Stories", 1, true);
            data.AddPortlet("http://feeds.bbci.co.uk/news/rss.xml", 1, "BBC News - Home", 2, false);
            data.AddPortlet("http://feeds.bbci.co.uk/news/world/rss.xml", 1, "BBC News - World", 2, false);
            data.AddPortlet("http://feeds.bbci.co.uk/news/politics/rss.xml", 2, "BBC News - Politics", 3, false);
            data.AddPortlet("http://www.msn.com/rss/news.aspx", 2, "MSN News", 3, false);
            data.AddPortlet("http://rss.news.yahoo.com/rss/world", 2, "Yahoo! News: World News", 3, true);
            data.AddPortlet("http://feeds.abcnews.com/abcnews/topstories", 3, "ABC News: Top Stories", 1, false);
            data.AddPortlet("http://feeds.abcnews.com/abcnews/internationalheadlines", 3, "ABC News:International Headlines", 2, false);
            data.AddPortlet("http://nytimes.com/timeswire/feeds/", 3, "NYT > Most Recent Headlines", 3, false);
            data.AddPortlet("http://feeds.eonline.com/eonline/topstories", 3, "Top Stories", 4, false);

            data.AddCategory("Technology");
            data.AddPortlet("http://feeds.abcnews.com/abcnews/technologyheadlines", 1, "ABC News: Technology", 1, false);
            data.AddPortlet("http://dsc.discovery.com/news/subjects/tech/xml/top-stories.xml", 1, "Discovery News - Technology", 1, false);
            data.AddPortlet("http://feeds.technologyreview.com/technology_review_computing", 1, "Computing Top Stories", 2, false);
            data.AddPortlet("http://feeds.technologyreview.com/technology_review_web", 1, "Web Top Stories", 3, false);
            data.AddPortlet("http://feeds.technologyreview.com/technology_review_communications", 1, "Communications Top Stories", 4, false);
            data.AddPortlet("http://feeds.technologyreview.com/technology_review_energy", 2, "Energy Top Stories", 1, false);
            data.AddPortlet("http://feeds.technologyreview.com/technology_review_biotech", 2, "Biomedicine Top Stories", 2, false);
            data.AddPortlet("http://feeds.technologyreview.com/technology_review_biztech", 2, "Business Impact Top Stories", 3, false);
            data.AddPortlet("http://feeds.technologyreview.com/technology_review_video", 3, "Video", 4, false);
            data.AddPortlet("http://feeds.technologyreview.com/technology_review_blog_editors", 3, "TR Editors' blog", 5, false);
            data.AddPortlet("http://news.cnet.com/2547-1_3-0-20.xml?tag=aboutCNET;rss", 3, "CNET News.com", 5, false);
            data.AddPortlet("http://rss.news.yahoo.com/rss/personaltech", 3, "Yahoo! News: Gadgets & Personal Technology", 5, true);
            data.AddPortlet("http://rss.news.yahoo.com/rss/software", 3, "Yahoo! News: Software News", 5, true);

            data.AddCategory("Weather");
            data.AddPortlet("http://newsrss.bbc.co.uk/weather/forecast/2189/Next3DaysRSS.xml", 1, "BBC Next 3 Days Forecast", 1, false);
            data.AddPortlet("http://rss.cnn.com/rss/edition.rss", 2, "CNN Top stories", 2, false);
            data.AddPortlet("http://rss.news.yahoo.com/rss/weather", 3, "Yahoo! News: Weather News", 5, true);

            data.AddCategory("Sports");
            data.AddPortlet("http://feeds.abcnews.com/abcnews/sportsheadlines", 1, "ABC News: ESPN Sports", 1, false);
            data.AddPortlet("http://rss.news.yahoo.com/rss/sports", 2, "Yahoo! News: Sports News", 5, true);

            data.AddCategory("Business");
            data.AddPortlet("http://feeds.bbci.co.uk/news/business/rss.xml", 1, "BBC News - Business", 1, false);
            data.AddPortlet("http://feeds.abcnews.com/abcnews/moneyheadlines", 1, "ABC News - Money Headlines", 2, false);
            data.AddPortlet("http://rss.news.yahoo.com/rss/stocks", 2, "Yahoo Stock Market News", 3, true);
            data.AddPortlet("http://rss.news.yahoo.com/rss/business", 2, "Yahoo! News: Business News", 3, true);
            data.AddPortlet("http://rss.news.yahoo.com/rss/earnings", 3, "Yahoo! News: Earnings News", 3, true);
            data.AddPortlet("http://rss.news.yahoo.com/rss/energy", 3, "Yahoo! News: Business - Energy & Oil Industry", 5, true);

            data.AddCategory("Entertainment");
            data.AddPortlet("http://feeds.bbci.co.uk/news/entertainment_and_arts/rss.xml", 1, "BBC News - Entertainment & Arts", 1, false);
            data.AddPortlet("http://feeds.abcnews.com/abcnews/entertainmentheadlines", 1, "ABC News: Entertainment", 2, false);
            data.AddPortlet("http://rss.news.yahoo.com/rss/celebrity", 2, "Yahoo! News: Gossip/Celebrity News", 5, true);
            data.AddPortlet("http://rss.news.yahoo.com/rss/music", 3, "Yahoo! News: Music News", 5, true);

            data.AddCategory("Health");
            data.AddPortlet("http://rss.news.yahoo.com/rss/weightloss", 1, "Yahoo! News: Weight Loss News", 1, true);
            data.AddPortlet("http://feeds.abcnews.com/abcnews/healthheadlines", 1, "ABC News: Health", 2, false);
            data.AddPortlet("http://rss.news.yahoo.com/rss/meds", 2, "Yahoo! News: Medications/Drugs News", 5, true);
            data.AddPortlet("http://rss.news.yahoo.com/rss/seniors", 2, "Yahoo! News: Seniors/Aging News", 5, true);
            data.AddPortlet("http://rss.news.yahoo.com/rss/cancer", 3, "Yahoo! News: Health - Cancer", 5, true);

            data.AddCategory("Travel");
            data.AddPortlet("http://feeds.abcnews.com/abcnews/travelheadlines", 1, "ABC News: Travel", 1, false);
            data.AddPortlet("http://feeds.feedzilla.com/en_pk/news_headlines/entertainment/music.rss", 2, "Music", 2, false);

            data.AddCategory("Youtube");
            data.AddPortlet("http://gdata.youtube.com/feeds/base/standardfeeds/most_recent?client=ytapi-youtube-browse&alt=rss", 1, "Most Recent", 1, false);
            data.AddPortlet("http://gdata.youtube.com/feeds/base/standardfeeds/recently_featured?client=ytapi-youtube-browse&alt=rss", 1, "Spotlight Videos", 2, false);
            data.AddPortlet("http://gdata.youtube.com/feeds/base/standardfeeds/top_favorites?client=ytapi-youtube-browse&alt=rss", 1, "Top Favorites Today", 3, false);
            data.AddPortlet("http://gdata.youtube.com/feeds/base/standardfeeds/top_favorites?client=ytapi-youtube-browse&alt=rss&time=today", 1, "Top Favorites Today", 4, false);
            data.AddPortlet("http://gdata.youtube.com/feeds/base/standardfeeds/top_rated?client=ytapi-youtube-browse&alt=rss", 2, "Top Rated", 1, false);
            data.AddPortlet("http://gdata.youtube.com/feeds/base/standardfeeds/top_rated?client=ytapi-youtube-browse&alt=rss&time=today", 2, "Top Rated Today", 2, false);
            data.AddPortlet("http://gdata.youtube.com/feeds/base/standardfeeds/most_viewed?client=ytapi-youtube-browse&alt=rss&time=today", 2, "Most Viewed Today", 3, false);
            data.AddPortlet("http://gdata.youtube.com/feeds/base/standardfeeds/most_viewed?client=ytapi-youtube-browse&alt=rss&time=this_week", 3, "Most Viewed This Week", 4, false);
            data.AddPortlet("http://gdata.youtube.com/feeds/base/standardfeeds/most_viewed?client=ytapi-youtube-browse&alt=rss&time=this_month", 3, "Most Viewed This Month", 5, false);
            data.AddPortlet("http://gdata.youtube.com/feeds/base/standardfeeds/most_viewed?client=ytapi-youtube-browse&alt=rss&time=all_time", 3, "Most Viewed All Time", 3, false);
            data.AddPortlet("http://gdata.youtube.com/feeds/base/standardfeeds/most_discussed?client=ytapi-youtube-browse&alt=rss&time=today", 3, "Most Discussed Videos Today", 4, false);
            data.AddPortlet("http://gdata.youtube.com/feeds/base/standardfeeds/most_discussed?client=ytapi-youtube-browse&alt=rss&time=this_week", 1, "Most Discussed Videos This Week", 1, false);
            data.AddPortlet("http://gdata.youtube.com/feeds/base/standardfeeds/most_discussed?client=ytapi-youtube-browse&alt=rss&time=this_month", 3, "Most Discussed Videos This Month", 2, false);

            data.AddCategory("Discovery Channel");
            data.AddPortlet("http://dsc.discovery.com/news/xml/top-stories.xml", 1, "Discovery News - Headlines", 1, false);
            data.AddPortlet("http://www.discovery.com/radio/xml/news_video.xml", 1, "Discovery News - Video", 2, false);
            data.AddPortlet("http://dsc.discovery.com/news/xml/bloggers.xml", 1, "Discovery News - Blogs", 3, false);
            data.AddPortlet("http://dsc.discovery.com/news/subjects/animals/xml/top-stories.xml", 1, "Discovery News - Animals", 4, false);
            data.AddPortlet("http://dsc.discovery.com/news/subjects/archaeology/xml/top-stories.xml", 2, "Discovery News - Archaeology", 1, false);
            data.AddPortlet("http://dsc.discovery.com/news/subjects/dinosaurs/xml/top-stories.xml", 2, "Discovery News - Dinosaurs", 2, false);
            data.AddPortlet("http://dsc.discovery.com/news/subjects/health/xml/top-stories.xml", 2, "Discovery News - Health", 3, false);
            data.AddPortlet("http://dsc.discovery.com/news/subjects/human/xml/top-stories.xml", 3, "Discovery News - Human Interest", 4, false);
            data.AddPortlet("http://dsc.discovery.com/news/subjects/history/xml/top-stories.xml", 3, "Discovery News - History", 5, false);
            data.AddPortlet("http://dsc.discovery.com/news/subjects/earth/xml/top-stories.xml", 3, "Discovery News - Planet Earth", 3, false);
            data.AddPortlet("http://dsc.discovery.com/news/subjects/space/xml/top-stories.xml", 3, "Discovery News - Space", 4, false);
            data.AddPortlet("http://dsc.discovery.com/news/subjects/tech/xml/top-stories.xml", 1, "Discovery News - Technology", 1, false);

            Application["data"] = data.Complete();
        }

        public void Session_OnStart()
        {
            WebApplication.Models.ds _dsSession = new WebApplication.Models.ds();
            WebApplication.Models.ds _dsApplication = (WebApplication.Models.ds) Application["data"];
            _dsSession.EnforceConstraints = false;

            System.Data.DataRow[] rows = _dsApplication.Portlet.Select();
            System.Data.DataRow rowTemp;
            foreach( System.Data.DataRow row in  rows )
            {
                rowTemp = _dsSession.Portlet_User.NewRow();
                rowTemp["Category_ID"] = row["Category_ID"];
                rowTemp["User_ID"] = Session.Count + 1;
                rowTemp["Portlet_ID"] = row["Portlet_ID"];
                rowTemp["Column_No"] = row["Column_No"];
                rowTemp["Row_Sequence"] = row["Row_Sequence"];
                rowTemp["Title"] = row["Title"];
                rowTemp["Is_Image_Allowed"] = row["Is_Image_Allowed"];
                rowTemp["Is_Active"] = true;
                _dsSession.Portlet_User.Rows.Add(rowTemp);
            }

            Session["data"] = _dsSession;
        }
         


    }
}